degree_linadd=8
degree_direct=8
degree_direct_from=8
start_degree_hashed=0 #7
degree_hashed=20
degree_hashed_from=20
C=1
epsilon=1e-2
num_threads=8
hash_bits=[12] #range(8,16)
use_bias=True
num=1000000
use_hashed=True
use_direct=False
transposed=True

#train_filename='/tmp/x'
#test_filename='/tmp/x'
#label_train_filename='/tmp/y'
#label_test_filename='/tmp/y'

train_filename='data/H_sapiens_acc_all_examples_plain_139-279_' + `num` + '.fasta'
label_train_filename='data/H_sapiens_acc_all_examples_plain_' +`num` +'.label'
test_filename='data/H_sapiens_acc_all_examples_plain_139-279_100000_val.fasta'
label_test_filename='data/H_sapiens_acc_all_examples_plain_100000_val.label'
#test_filename='data/H_sapiens_acc_all_examples_plain_139-279_5e7_test.fasta'
#label_test_filename='data/H_sapiens_acc_all_examples_plain_5e7_test.label'

from shogun.Features import StringCharFeatures, StringByteFeatures, \
		StringWordFeatures, CombinedDotFeatures, \
		WDFeatures, HashedWDFeatures, HashedWDFeaturesTransposed, \
		ImplicitWeightedSpecFeatures, Labels, DNA, RAWDNA
from shogun.PreProc import SortWordString
from shogun.Classifier import LibLinear, SVMSGD, SVMOcas, L2R_L1LOSS_SVC_DUAL, L2R_L2LOSS_SVC, L2R_L2LOSS_SVC_DUAL
from shogun.Library import MSG_INFO, MSG_DEBUG

from shogun.Features import StringCharFeatures, StringWordFeatures,\
		CombinedFeatures, CombinedDotFeatures, WDFeatures, \
		ImplicitWeightedSpecFeatures, Labels, DNA
from shogun.Kernel import WeightedDegreeStringKernel, \
		WeightedCommWordStringKernel, CombinedKernel
from shogun.PreProc import SortWordString
from shogun.Library import MSG_INFO, MSG_DEBUG

from shogun.Classifier import SVMLight, LibLinear, SVMSGD, SVMOcas

import evaluation
import numpy
import time

def read_lab(fname):
	x=file(fname).readlines()
	return numpy.array([ float(i) for i in x ])

def train_hashed(num_hash_bits):
	labels_train=read_lab(label_train_filename)
	labels_test=read_lab(label_test_filename)

	feats_train_center_raw=StringByteFeatures(DNA)
	feats_train_center_raw.io.set_loglevel(MSG_DEBUG)
	feats_train_center_raw.io.enable_progress()
	feats_train_center_raw.load_dna_file(train_filename)
	if use_direct:
		feats_train_center_low=WDFeatures(feats_train_center_raw, degree_direct, degree_direct_from)
	if use_hashed:
		if transposed:
			feats_train_center_high_t=HashedWDFeaturesTransposed(feats_train_center_raw, start_degree_hashed, degree_hashed, degree_hashed_from, num_hash_bits)
		else:
			feats_train_center_high=HashedWDFeatures(feats_train_center_raw, start_degree_hashed, degree_hashed, degree_hashed_from, num_hash_bits)

		#for i in [0,1,2]:
		#	for j in [0,1,2]:
		#		print i,j, feats_train_center_high.dot(i,j),feats_train_center_high_t.dot(i,j),
		#		x=numpy.dot(feats_train_center_high.get_feature_vector(i),feats_train_center_high.get_feature_vector(j))
		#		y=numpy.dot(feats_train_center_high_t.get_feature_vector(i),feats_train_center_high_t.get_feature_vector(j))
		#		print x,y


	feats_test_center_raw=StringByteFeatures(DNA)
	feats_test_center_raw.load_dna_file(test_filename)

	if use_direct:
		feats_test_center_low=WDFeatures(feats_test_center_raw, degree_direct, degree_direct_from)
	if use_hashed:
		if transposed:
			feats_test_center_high_t=HashedWDFeaturesTransposed(feats_test_center_raw, start_degree_hashed, degree_hashed, degree_hashed_from, num_hash_bits)
		else:
			feats_test_center_high=HashedWDFeatures(feats_test_center_raw, start_degree_hashed, degree_hashed, degree_hashed_from, num_hash_bits)

	if use_direct and use_hashed:
		c=feats_train_center_high.get_normalization_const()
		feats_train_center_low.set_normalization_const(c)
		feats_train_center_high.set_normalization_const(c)
		#feats_test_center_low.set_normalization_const(c)
		#feats_test_center_high.set_normalization_const(c)

	feats_train=CombinedDotFeatures()
	feats_train.io.enable_progress()
	if use_direct:
		feats_train.append_feature_obj(feats_train_center_low)
	if use_hashed:
		if transposed:
			#feats_train=feats_train_center_high_t
			feats_train.append_feature_obj(feats_train_center_high_t)
		else:
			feats_train.append_feature_obj(feats_train_center_high)


	feats_test=CombinedDotFeatures()
	if use_direct:
		feats_test.append_feature_obj(feats_test_center_low)
	if use_hashed:
		if transposed:
			feats_test.append_feature_obj(feats_test_center_high_t)
			#feats_test=feats_test_center_high_t
		else:
			feats_test.append_feature_obj(feats_test_center_high)

	#feats_train.benchmark_add_to_dense_vector()
	feats_train.parallel.set_num_threads(num_threads)
	feats_train.benchmark_dense_dot_range(1)
	#return

	#feats_test.benchmark_add_to_dense_vector(1)
	#feats_test.parallel.set_num_threads(num_threads)
	#feats_test.benchmark_dense_dot_range(1)
	# train svm
	#svm=SVMOcas(C, feats_train, Labels(labels_train))
	svm=LibLinear(C, feats_train, Labels(labels_train))
	#svm.set_liblinear_solver_type(L2R_L2LOSS_SVC)
	svm.set_liblinear_solver_type(L2R_L1LOSS_SVC_DUAL)

	svm.io.enable_progress()
	svm.set_bias_enabled(use_bias)
	#svm.set_epochs(30)

	svm.set_epsilon(epsilon)
	svm.parallel.set_num_threads(num_threads)
	start = time.clock()
	svm.set_bias_enabled(use_bias)

	svm.train()
	elapsed = (time.clock() - start)
	out=svm.classify(feats_test).get_labels()

	return (evaluation.compute_scores(out, labels_test), elapsed)

def train_linadd():
	labels_train=read_lab(label_train_filename)
	labels_test=read_lab(label_test_filename)
	# wd center
	kernel=WeightedDegreeStringKernel(degree_linadd)
	feats_train=StringCharFeatures(DNA)
	feats_train.load_dna_file(train_filename, False)
	feats_test=StringCharFeatures(DNA)
	feats_test.load_dna_file(test_filename, False)

	kernel.init(feats_train, feats_train)
	svm=SVMLight(C, kernel, Labels(labels_train))
	svm.set_bias_enabled(use_bias)
	svm.io.enable_progress()
	svm.set_epsilon(epsilon)
	svm.parallel.set_num_threads(num_threads)
	svm.set_bias_enabled(use_bias)
	start = time.clock()
	svm.train()
	elapsed = (time.clock() - start)
	kernel.init(feats_train, feats_test)
	out=svm.classify().get_labels()

	return (evaluation.compute_scores(out, labels_test), elapsed)

#results_linadd=train_linadd()

#print "linadd results", results_linadd

results_hashed=dict()
for h in hash_bits:
	print "hash_bits", h
	results_hashed[h]=train_hashed(h)
	print results_hashed[h]
	#break
