transition_degree=[0,2,3,4,5,6,7,8,9]
start_degree_direct=0
degree_hashed=20
num_threads=1
num_hash_bits=12
use_bias=True
num=100000
use_hashed=True

train_filename='data/H_sapiens_acc_all_examples_plain_139-279_' + `num` + '.fasta'

from shogun.Features import StringCharFeatures, StringByteFeatures, \
		StringWordFeatures, CombinedDotFeatures, \
		WDFeatures, HashedWDFeatures, ImplicitWeightedSpecFeatures, Labels, DNA, RAWDNA
from shogun.PreProc import SortWordString
from shogun.Classifier import LibLinear, SVMSGD, SVMOcas, L2R_L1LOSS_SVC_DUAL, L2R_L2LOSS_SVC, L2R_L2LOSS_SVC_DUAL
from shogun.Library import MSG_INFO, MSG_DEBUG

from shogun.Features import StringCharFeatures, StringWordFeatures,\
		CombinedFeatures, CombinedDotFeatures, WDFeatures, \
		ImplicitWeightedSpecFeatures, Labels, DNA
from shogun.Kernel import WeightedDegreeStringKernel, \
		WeightedCommWordStringKernel, CombinedKernel
from shogun.PreProc import SortWordString
from shogun.Library import MSG_INFO, MSG_DEBUG

from shogun.Classifier import SVMLight, LibLinear, SVMSGD, SVMOcas

import evaluation
import numpy
import time

def train_hashed(transition_degree):
	if transition_degree==0:
		use_direct=False
	else:
		use_direct=True

	degree_direct=transition_degree-1
	start_degree_hashed=transition_degree

	feats_train_center_raw=StringByteFeatures(DNA)
	#feats_train_center_raw.io.set_loglevel(MSG_DEBUG)
	feats_train_center_raw.io.enable_progress()
	feats_train_center_raw.load_dna_file(train_filename)
	if use_direct:
		feats_train_center_low=WDFeatures(feats_train_center_raw, degree_direct, degree_direct)
	if use_hashed:
		feats_train_center_high=HashedWDFeatures(feats_train_center_raw, start_degree_hashed, degree_hashed, degree_hashed, num_hash_bits)

	feats_train=CombinedDotFeatures()
	if use_direct:
		feats_train.append_feature_obj(feats_train_center_low)
	if use_hashed:
		feats_train.append_feature_obj(feats_train_center_high)

	feats_train.parallel.set_num_threads(num_threads)
	start = time.clock()
	feats_train.benchmark_add_to_dense_vector(1)
	feats_train.benchmark_dense_dot_range(1)
	elapsed = (time.clock() - start)
	return elapsed

results_hashed=dict()
for d in transition_degree:
	print "transition_degree", d
	results_hashed[d]=train_hashed(d)
	print results_hashed[d]
